/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */


#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/****************************************************************************************/
void save_name_dat()
{
	char tstring[250];
	FILE *outfile;
	extern char *datapath, symbol[SYMBOL_SIZE], name[NAME_SIZE], *error_message;
	extern char cant_open_chart[];
	extern display_message();
	
	
	strcpy(tstring, datapath);
	strcat(tstring, symbol);
	outfile = fopen(tstring, "r+b");
	if (! outfile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fwrite(&name, NAME_SIZE, 1, outfile);
	fclose(outfile);
}
/****************************************************************************************/
void save_symbol_dat()
{
	char tstring[250];
	FILE *outfile;
	extern char *datapath, symbol[SYMBOL_SIZE], *error_message, cant_open_chart[];
	extern display_message();
	
	
	strcpy(tstring, datapath);
	strcat(tstring, symbol);
	outfile = fopen(tstring, "r+b");
	if (! outfile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fseek(outfile, (long)NAME_SIZE, SEEK_SET);
	fwrite(&symbol, SYMBOL_SIZE, 1, outfile);
	fclose(outfile);
}
/****************************************************************************************/
void save_volume_dat()
{
	char tstring[250];
	FILE *outfile;
	extern int volume;
	extern char symbol[SYMBOL_SIZE], *datapath, *error_message, cant_open_chart[];
	extern display_message();
	
	
	strcpy(tstring, datapath);
	strcat(tstring, symbol);
	outfile = fopen(tstring, "r+b");
	if (! outfile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fseek(outfile, (long)(NAME_SIZE + SYMBOL_SIZE), SEEK_SET);
	fwrite(&volume, sizeof(int), 1, outfile);
	fclose(outfile);
}
/****************************************************************************************/
void save_moving_dat()
{
	char tstring[250];
	FILE *outfile;
	extern int moving;
	extern char symbol[SYMBOL_SIZE], *datapath, *error_message, cant_open_chart[];
	extern display_message();
	
	
	strcpy(tstring, datapath);
	strcat(tstring, symbol);
	outfile = fopen(tstring, "r+b");
	if (! outfile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fseek(outfile, (long)(NAME_SIZE + SYMBOL_SIZE + sizeof(int)), SEEK_SET);
	fwrite(&moving, sizeof(int), 1, outfile);
	fclose(outfile);
}
/****************************************************************************************/
void save_volumeroc_dat()
{
	char tstring[250];
	FILE *outfile;
	extern float volumeroc;
	extern char symbol[SYMBOL_SIZE], *datapath, *error_message, cant_open_chart[];
	extern display_message();
	
	
	strcpy(tstring, datapath);
	strcat(tstring, symbol);
	outfile = fopen(tstring, "r+b");
	if (! outfile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fseek(outfile, (long)(NAME_SIZE + SYMBOL_SIZE + sizeof(int) + sizeof(int)), SEEK_SET);
	fwrite(&volumeroc, sizeof(float), 1, outfile);
	fclose(outfile);
}
/****************************************************************************************/
void save_closeroc_dat()
{
	char tstring[250];
	FILE *outfile;
	extern float closeroc;
	extern char symbol[SYMBOL_SIZE], *datapath, *error_message, cant_open_chart[];
	extern display_message();
	
	
	strcpy(tstring, datapath);
	strcat(tstring, symbol);
	outfile = fopen(tstring, "r+b");
	if (! outfile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fseek(outfile, (long)(NAME_SIZE + SYMBOL_SIZE + sizeof(int) + sizeof(int) + sizeof(float)), SEEK_SET);
	fwrite(&closeroc, sizeof(float), 1, outfile);
	fclose(outfile);
}
/****************************************************************************************/
void save_threshold_dat()
{
	char tstring[250];
	FILE *outfile;
	extern float threshold;
	extern char symbol[SYMBOL_SIZE], *datapath, *error_message, cant_open_chart[];
	extern display_message();
	
	
	strcpy(tstring, datapath);
	strcat(tstring, symbol);
	outfile = fopen(tstring, "r+b");
	if (! outfile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fseek(outfile, (long)(NAME_SIZE + SYMBOL_SIZE + sizeof(int) + sizeof(int) + sizeof(float) + sizeof(float)), SEEK_SET);
	fwrite(&threshold, sizeof(float), 1, outfile);
	fclose(outfile);
}
/*****************************************************************************************/
void load_alerts()
{
	
	char tstring[250];
	FILE *infile;
	int tint;
	extern char *datapath, *global_string, *error_message, cant_open_chart[];
	extern float volumeroc, closeroc, threshold;
	extern display_message(), update_stats_bar();
	
	
	strcpy(tstring, datapath);
	strcat(tstring, global_string);
	infile = fopen(tstring, "rb");
	if (! infile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fread(&tstring, NAME_SIZE, 1, infile);
	fread(&tstring, SYMBOL_SIZE, 1, infile);
	fread(&tint, sizeof(int), 1, infile);
	fread(&tint, sizeof(int), 1, infile);
	fread(&volumeroc, sizeof(float), 1, infile);
	fread(&closeroc, sizeof(float), 1, infile);
	fread(&threshold, sizeof(float), 1, infile);
	fclose(infile);
}
/******************************************************************************************/
void load_file()
{
	char *tstringpointer, tstring[250], tstring2[25];
	unsigned long tlong, tlong2, tlong3, loaddate = 0;
	long *openint_pointer = NULL, *volume_pointer, *date_pointer;
	int  tint;
	float *open_pointer = NULL, *high_pointer, *low_pointer, *close_pointer;
	float tfloat, tfloat2, tfloat3, tfloat4;
   	FILE *infile;
   	extern int chartflag, open_file_flag, group_pointer, entries, styleflag, pixelspace;
   	extern char *groupfilename, *global_string, *error_message;
   	extern display_message(), draw(), update_stats_bar();
	extern float *open_array, *high_array, *low_array, *close_array, maxhigh, maxlow, range;
	extern long *openint_array, volume_high, *date_array, *volume_array;
	extern GtkWidget *chart, *main_window;
	extern char symbol[SYMBOL_SIZE], name[NAME_SIZE], *datapath, cant_open_group[];
	extern char cant_open_chart[], group_empty[];
	extern int top_enable_flag, volume, moving, bars;
	extern float volumeroc, closeroc, threshold;
	
	
	
	if (open_file_flag < 1)
	{
		infile = fopen(groupfilename, "rb");
		if (! infile)
		{
			error_message = cant_open_group;
			display_message();
			return;
		}
		fseek(infile, group_pointer * GROUP_RECORDSIZE, SEEK_SET);
		fread(&tstring, GROUP_RECORDSIZE, 1, infile);
		sscanf(tstring, "%s", tstring2);
		if (global_string != NULL)
			free(global_string);
		global_string = (char *)malloc(sizeof(tstring2) + 1);
		strcpy(global_string, tstring2);
		fclose(infile);
        	if (strlen(global_string) == 0)
        	{
        		error_message = group_empty;
			display_message();
      			return;
      		}
        }
        chartflag = 1;
	maxhigh = 0;
	maxlow = 9999999;
	volume_high = 0;
	
	strcpy(tstring, datapath);
	strcat(tstring, global_string);
	infile = fopen (tstring,"rb");
	if (! infile)
	{
		error_message = cant_open_chart;
		display_message();
     		return;
	}
	fseek(infile, 0L, SEEK_END);
	tlong = ftell(infile);
	tlong = tlong - HEADERSIZE;
	entries = tlong / RECORDSIZE;
	fseek(infile, 0L, SEEK_SET);
	fread(&name, NAME_SIZE, 1, infile);
	fread(&symbol, SYMBOL_SIZE, 1, infile);
	fread(&volume, sizeof(int), 1, infile);
	fread(&moving, sizeof(int), 1, infile);
	fread(&volumeroc, sizeof(float), 1, infile);
	fread(&closeroc, sizeof(float), 1, infile);
	fread(&threshold, sizeof(float), 1, infile);
	if (close_array != NULL)
		free(close_array);
	if (high_array != NULL)
		free(high_array);
	if (low_array != NULL)
		free(low_array);
	if (volume_array != NULL)
		free(volume_array);
	if (date_array != NULL)
		free(date_array);
	if (open_array != NULL)
		free(open_array);
	if (openint_array != NULL)
		free(openint_array);
	if ((entries < bars) || (bars == 0))
	{
		close_array = (float*)malloc(entries * sizeof(float));
		high_array = (float*)malloc(entries * sizeof(float));
		low_array = (float*)malloc(entries * sizeof(float));
		volume_array = (unsigned long*)malloc(entries * sizeof(unsigned long));
		date_array = (unsigned long*)malloc(entries * sizeof(unsigned long));
		open_array = (float*)malloc(entries * sizeof(float));
		openint_array = (unsigned long*)malloc(entries * sizeof(unsigned long));
	}
	else
	{
		close_array = (float*)malloc(bars * sizeof(float));
		high_array = (float*)malloc(bars * sizeof(float));
		low_array = (float*)malloc(bars * sizeof(float));
		volume_array = (unsigned long*)malloc(bars * sizeof(unsigned long));
		date_array = (unsigned long*)malloc(bars * sizeof(unsigned long));
		open_array = (float*)malloc(bars * sizeof(float));
		openint_array = (unsigned long*)malloc(bars * sizeof(unsigned long));
	}
	close_pointer = close_array;
	high_pointer = high_array;
	low_pointer = low_array;
	volume_pointer = volume_array;
	date_pointer = date_array;
	open_pointer = open_array;
	openint_pointer = openint_array;
	loaddate = atol(global_string);
	if ((entries <= bars) || (bars == 0))
	{
		tint = 0;
		fseek(infile, HEADERSIZE, SEEK_SET);
	}
	else
	{
		tint =  entries - bars;
		fseek(infile, ((long)tint * RECORDSIZE) + HEADERSIZE, SEEK_SET);
	}
	for (tint = tint; tint < entries; tint++)
	{
		fread(&tlong, sizeof(unsigned long), 1, infile);
		fread(&tfloat, sizeof(float), 1, infile);
		fread(&tfloat2, sizeof(float), 1, infile);
		fread(&tfloat3, sizeof(float), 1, infile);
		fread(&tfloat4, sizeof(float), 1, infile);
		fread(&tlong2, sizeof(unsigned long), 1, infile);
		fread(&tlong3, sizeof(unsigned long), 1, infile);
		
         	*date_pointer = tlong;
         	*open_pointer = tfloat;
         	*high_pointer = tfloat2;
         	*low_pointer = tfloat3;
         	*close_pointer = tfloat4;
         	*volume_pointer = tlong2;
         	*openint_pointer = tlong3;
         	if (tfloat2 > maxhigh)
         		maxhigh = tfloat2;
         	if (tfloat3 < maxlow)
         		maxlow = tfloat3;
         	if (tlong2 > volume_high)
         		volume_high = tlong2;
      		close_pointer++;
      		high_pointer++;
      		low_pointer++;
      		volume_pointer++;
      		date_pointer++;
      		open_pointer++;
      		openint_pointer++;
	}
	fclose(infile);
	if ((entries >= bars) && (bars != 0))
		entries =  bars;
	tfloat = (maxhigh - maxlow) / 100;
	maxhigh = maxhigh + tfloat;
	maxlow = maxlow - tfloat;
	range = maxhigh - maxlow;
	if (open_file_flag == 1)
	{
		strcpy(tstring, "gstalker: ");
		strcat(tstring, name);
		strcat(tstring, " (");
		strcat(tstring, symbol);
		strcat(tstring, ")");
	}
	else
	{
		strcpy(tstring, "gstalker: [");
		tstringpointer = strrchr(groupfilename, '/');
		strcat(tstring, tstringpointer + 1);
		strcat(tstring, "] - ");
		strcat(tstring, name);
		strcat(tstring, " (");
		strcat(tstring, symbol);
		strcat(tstring, ")");
	}
	gtk_window_set_title (GTK_WINDOW (main_window), tstring);
	
	if (top_enable_flag)
		update_stats_bar();
       	
	if (styleflag == 1)
	{
		if (pixelspace < 4)
			pixelspace = 4;
	}
	else
	{
		if (pixelspace < 1)
			pixelspace = 1;
	}
	gtk_widget_set_usize(GTK_WIDGET (chart), entries * pixelspace, 0);
	draw();
}        